Terminal Window Never Shows Up

Bug #186109 reported by Mike T. on 2008-01-26
14
Affects Status Importance Assigned to Milestone
sshmenu (Ubuntu)
Undecided
Unassigned

Bug Description

Binary package hint: sshmenu

I have recently upgraded through apt-get to the latest Hardy release and found out that sshmenu 3.14-2 (installed from the Ubuntu repos) doesn't seem to work properly.

Steps to reproduce:
- Install sshmenu 3.14-2 from the repos via Synaptic or apt-get
- Add a Host to the sshmenu applet with the following config
Title: domain.com
Hostname (etc): <email address hidden>

- Save the new host and then click the option you just created from sshmenu. Your terminal window will never show up.

P.S. I know ssh is installed and working properly as I can open a Terminal window manually and run the following command just fine:
ssh <email address hidden>

GrantMcLean (grant-mclean) wrote :

I'm the developer of SSHMenu - here's my response to a similar report on SourceForge:

I don't have access to a system with the latest gnome-terminal, so remote debugging is the order of the day :-)

Ultimately, all SSHMenu does is call gnome-terminal with a list of arguments. I'm guessing that the gnome-terminal segfault will be reproducible if we can directly invoke gnome-terminal with the same arguments - and thus take SSHMenu out of the equation.

Looking at the commit history for gnome-terminal, it looks like command-line option handling was ported from popt to Goption in January and this may be relevant.

It's also possible that gnome-terminal's valid options have changed and SSHMenu will need to be tweaked to generate command lines compatible with the new version.

If a host is defined in SSHMenu with these parameters ...

Title: Local Host
Hostname: localhost
Geometry:
Profile: <None>

... then this is the command which will be run:

gnome-terminal --title="Local Host" -e "sh -c \"ssh localhost\""

If the geometry is set to the top right corner then this command will be run:

gnome-terminal --geometry=80x24-0+25 --title="Local Host" -e "sh -c \"ssh localhost\""

If the "Big Font" profile is selected, then this command will be run:

gnome-terminal --geometry=80x24-0+25 --window-with-profile="Big Font" --title="Local Host" -e "sh -c \"ssh localhost\""

If a non-Unicode Polish locale is selected by setting:

Hostname: LC_ALL="pl_PL.iso-8859-2" localhost

Then this command will be run:

LC_ALL="pl_PL.iso-8859-2" gnome-terminal --disable-factory --geometry=80x24-0+25 --window-with-profile="Big Font" --title="Local Host" -e "sh -c \"ssh localhost\""

Can you please try these commands and see if any of them cause the same segfault?

The latest version of sshmenu.rb in subversion accepts a '-d' option which enables debugging output to STDOUT. I use it by invoking the standalone (non-applet) version of SSHMenu like this:

  sshmenu-gnome -d

The latest version of this library is here:

https://sshmenu.svn.sourceforge.net/svnroot/sshmenu/modules/sshmenu/trunk/lib/sshmenu.rb

Let me know how you get on.

Thanks
Grant
<email address hidden>

GrantMcLean (grant-mclean) wrote :

The original submitter reported via email that this command-line failed when running
gnome-terminal directly:

  gnome-terminal --title="Local Host" -e "sh -c \"ssh localhost\""

I passed the report on to the gnome-terminal maintainers who responded
immediately with this patch:

  http://svn.gnome.org/viewvc/gnome-terminal?view=revision&revision=2373

It should fix the gnome-terminal segfault,but we'll have to wait and see
whether SSHMenu works with the new gnome-terminal.

Mike T. (mike-webco) wrote :
Download full text (9.1 KiB)

Thanks for the response Grant. Here is the result of running the gnome-terminal command directly. My guess is that the next gnome-terminal update will fix this problem.

michael@michael-laptop:~$ gnome-terminal --geometry=80x24-0+25 --title="Local Host" -e "sh -c \"ssh localhost\""

(gnome-terminal:8230): GLib-CRITICAL **: unquote_string_inplace: assertion `err == NULL || *err == NULL' failed
*** glibc detected *** gnome-terminal: free(): invalid pointer: 0xb7f6dc40 ***
======= Backtrace: =========
/lib/tls/i686/cmov/libc.so.6[0xb750b975]
/lib/tls/i686/cmov/libc.so.6(cfree+0x90)[0xb750f3e0]
/usr/lib/libglib-2.0.so.0(g_free+0x31)[0xb7739c21]
/usr/lib/libglib-2.0.so.0(g_error_free+0x29)[0xb7722c39]
gnome-terminal[0x805e510]
/usr/lib/libglib-2.0.so.0[0xb773f647]
/usr/lib/libglib-2.0.so.0[0xb773fb94]
/usr/lib/libglib-2.0.so.0(g_option_context_parse+0x3bd)[0xb774006d]
/usr/lib/libgnome-2.so.0(gnome_program_parse_args+0xe1)[0xb7e920b1]
/usr/lib/libgnome-2.so.0[0xb7e933bd]
/usr/lib/libgnome-2.so.0(gnome_program_init+0x71)[0xb7e936f1]
gnome-terminal[0x805f193]
/lib/tls/i686/cmov/libc.so.6(__libc_start_main+0xe0)[0xb74b6450]
gnome-terminal[0x8054761]
======= Memory map: ========
08048000-08081000 r-xp 00000000 08:01 1049143 /usr/bin/gnome-terminal
08081000-08083000 rwxp 00039000 08:01 1049143 /usr/bin/gnome-terminal
08083000-080ac000 rwxp 08083000 00:00 0 [heap]
b6900000-b6921000 rwxp b6900000 00:00 0
b6921000-b6a00000 ---p b6921000 00:00 0
b6adf000-b6ae8000 r-xp 00000000 08:01 2342925 /lib/tls/i686/cmov/libnss_files-2.7.so
b6ae8000-b6aea000 rwxp 00008000 08:01 2342925 /lib/tls/i686/cmov/libnss_files-2.7.so
b6aea000-b6af2000 r-xp 00000000 08:01 2342927 /lib/tls/i686/cmov/libnss_nis-2.7.so
b6af2000-b6af4000 rwxp 00007000 08:01 2342927 /lib/tls/i686/cmov/libnss_nis-2.7.so
b6af4000-b6afb000 r-xp 00000000 08:01 2342923 /lib/tls/i686/cmov/libnss_compat-2.7.so
b6afb000-b6afd000 rwxp 00006000 08:01 2342923 /lib/tls/i686/cmov/libnss_compat-2.7.so
b6b11000-b6b50000 r-xp 00000000 08:01 1114402 /usr/lib/locale/en_US.utf8/LC_CTYPE
b6b50000-b6c30000 r-xp 00000000 08:01 1114403 /usr/lib/locale/en_US.utf8/LC_COLLATE
b6c30000-b6c33000 rwxp b6c30000 00:00 0
b6c33000-b6c36000 r-xp 00000000 08:01 2310467 /lib/libgpg-error.so.0.3.0
b6c36000-b6c37000 rwxp 00002000 08:01 2310467 /lib/libgpg-error.so.0.3.0
b6c37000-b6c38000 rwxp b6c37000 00:00 0
b6c38000-b6c3c000 r-xp 00000000 08:01 1049471 /usr/lib/libXdmcp.so.6.0.0
b6c3c000-b6c3d000 rwxp 00003000 08:01 1049471 /usr/lib/libXdmcp.so.6.0.0
b6c3d000-b6c73000 r-xp 00000000 08:01 2310167 /lib/libsepol.so.1
b6c73000-b6c74000 rwxp 00035000 08:01 2310167 /lib/libsepol.so.1
b6c74000-b6c7e000 rwxp b6c74000 00:00 0
b6c7e000-b6cc9000 r-xp 00000000 08:01 2310472 /lib/libgcrypt.so.11.2.3
b6cc9000-b6ccb000 rwxp 0004a000 08:01 2310472 /lib/libgcrypt.so.11.2.3
b6ccb000-b6cda000 r-xp 00000000 08:01 1049821 /usr/lib/libtasn1.so.3.0.12
b6cda000-b6cdb000 rwxp 0000e000 08:01 1049821 /usr/lib/libtasn1.so.3.0.12
b6cdb000-b6cef000 r-xp 00000000 08:01 2342922 /lib/tls/i686/cmov/libnsl-2.7.so
b6cef000-b6cf1000 rwxp 00013000 08:01 2342922 /lib/tls/i686/cmov/libnsl-2.7.so...

Read more...

Pedro Fragoso (ember) on 2008-02-10
Changed in sshmenu:
assignee: nobody → ember
status: New → Fix Committed

How about applying the patch in https://bugs.launchpad.net/ubuntu/+source/sshmenu/+bug/186109/comments/2 and releasing a new one?

Pedro Fragoso (ember) wrote :
Pedro Fragoso (ember) wrote :

This bug was fixed in the package gnome-terminal - 2.21.91-0ubuntu1

---------------
gnome-terminal (2.21.91-0ubuntu1) hardy; urgency=low

  * New upstream release (LP: #189568)
    - Port to gio
    - Use of explicit suffix in 'Icon' field of application
      launcher (LP: #190688)
    - crash launching g-t with specific args (LP: #186109)
    - Disconnect from the settings notify on dispose
      instead of finalise. (LP: #188565)
  * debian/control{.in}:
    + Changed b-d libgnomevfs2-dev to libgvfscommon-dev
  * debian/patches/:
    - 01_lpi: updated
    - 02_autoconf: updated

 -- Pedro Fragoso <email address hidden> Mon, 11 Feb 2008 22:48:32 +0000

Changed in sshmenu:
status: Fix Committed → Fix Released
assignee: ember → nobody
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers